function DKPTooltip_OnLoad()
if(DKPT==nil) then
	DKPT={};
	DKPT['on']=true;
	DKPT['half']=true;
	DKPT['color']={
			tr=.45,
			tg=.45,
			tb=1,

			vr=.96,
			vg=.55,
			vb=.73,
			};
end

local DKPCOST_TEXT,DKPCOST_TEXT2 = "Full DKP-cost","Half DKP-cost";
local weight={
		INVTYPE_2HWEAPON=2,
		INVTYPE_WEAPON=1.5,
		INVTYPE_WEAPONMAINHAND=1.5,
		INVTYPE_WEAPONOFFHAND=1.5,

		INVTYPE_LEGS=1,
		INVTYPE_CHEST=1,
		INVTYPE_ROBE=1,
		INVTYPE_HEAD=1,

		INVTYPE_SHOULDER=0.75,
		INVTYPE_HAND=0.75,
		INVTYPE_WAIST=0.75,
		INVTYPE_FEET=0.75,
		INVTYPE_TRINKET=0.75,

		INVTYPE_WRIST=0.5,
		INVTYPE_NECK=0.5,
		INVTYPE_CLOAK=0.5,
		INVTYPE_FINGER=0.5,
		INVTYPE_HOLDABLE=0.5,
		INVTYPE_SHIELD=0.5,
		INVTYPE_RANGED=0.5,
		INVTYPE_RANGEDRIGHT=0.5,
		INVTYPE_THROWN=0.5,
		INVTYPE_RELIC=0.5
		};
local name, link, quality, ilevel, reqlevel, itype, isubtype, maxstack, equipslot, texture;

local function AddInfoToTooltip(tip, link)
	if(DKPT['on']) then
	name, link, quality, ilevel, reqlevel, itype, isubtype, maxstack, equipslot, texture = GetItemInfo(link);
	if(weight[equipslot]~=nil) then
		local value=0.0869*(2^(ilevel/26))*weight[equipslot];
		value=value-value%5;
		tip:AddDoubleLine(DKPCOST_TEXT, value, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb']);
		if(DKPT['half']) then
			if(value%2==1) then
				tip:AddDoubleLine(DKPCOST_TEXT2, value/2+.5, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb']);
			else
				tip:AddDoubleLine(DKPCOST_TEXT2, value/2, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb']);
			end
		end
		tip:Show();
	end
	end
end


-------- Tooltip hooking based on SellFish by Tuller. ----------

local function IsBagSlot(slot)
	return slot >= 20 and slot <= 23 or slot >= 68
end

local hooks = {
	SetHyperlink = function(link)
		return link
	end,

	SetLootItem = function(slot)
		if LootSlotIsItem(slot) then
			return GetLootSlotLink(slot)
		end
	end,

	SetLootRollItem = function(slot)
		return GetLootRollItemLink(slot)
	end,

	SetTradeTargetItem = function(id)
		return GetTradeTargetItemLink(id)
	end,

	SetBagItem = function(bag, slot)
		if not MerchantFrame:IsVisible() then
			return GetContainerItemLink(bag, slot)
		end
	end,

	SetInventoryItem = function(unit, slot)
		return GetInventoryItemLink(unit, slot)
	end,

	SetAuctionItem = function(type, index)
		return GetAuctionItemLink(type, index)
	end,

	SetAuctionSellItem = function()
		return select(2, GetItemInfo(GetAuctionSellItemInfo()))
	end,
--[[
	SetCraftItem = function(skill, id)
		return GetCraftReagentItemLink(skill, id)
	end,
]]--
	SetTradeSkillItem = function(skill, id)
		if id then
			return GetTradeSkillReagentItemLink(skill, id)
		end
		return GetTradeSkillItemLink(skill)
	end,

	SetQuestItem = function(type, index)
		return GetQuestItemLink(type, index)
	end,

	SetQuestLogItem = function(type, index)
		return GetQuestLogItemLink(type, index)
	end,

	SetInboxItem = function(id)
		return GetInboxItemLink(id)
	end,

	SetSendMailItem = function(id)
		return select(2, GetItemInfo(GetSendMailItem(id)))
	end,

	SetGuildBankItem = function(tab, slot)
		return GetGuildBankItemInfo(tab, slot)
	end,	
	
}

local function hookTip(tooltip, method, action)
	hooksecurefunc(tooltip, method, function(tip, ...)
		local link = action(...)
		if link then
			AddInfoToTooltip(tip, link)
		end
	end)
end

for method,func in pairs(hooks) do
	hookTip(GameTooltip, method, func)
end
hookTip(ItemRefTooltip, 'SetHyperlink', hooks.SetHyperlink)

----------------------------------------------------------------

	SLASH_DKPTOOLTIP1 = "/dkpt";
	SLASH_DKPTOOLTIP2 = "/dkptooltip";
	SlashCmdList["DKPTOOLTIP"] = DKPTooltip_Command;
end

function DKPTooltip_Command(msg)
	local cmd, subCmd = DKPTooltip_GetCmd(msg);
	if(cmd=="toggle") then
		DKPT['on']=not DKPT['on'];
		if(DKPT['on']) then
			print("DKPTooltip - Showing the DKP-cost is now enabled.");
		else
			print("DKPTooltip - Showing the DKP-cost is now disabled.");
		end
	elseif(cmd=="halfcost") then
		DKPT['half']=not DKPT['half'];
		if(DKPT['half']) then
			print("DKPTooltip - Showing the half DKP-cost.");
		else
			print("DKPTooltip - Not showing the half DKP-cost.");
		end
	elseif(cmd=="color") then
		local cmd, subCmd = DKPTooltip_GetCmd(subCmd);
		if(cmd=="text") then
			local tr, subCmd = DKPTooltip_GetCmd(subCmd);
			local tg, subCmd = DKPTooltip_GetCmd(subCmd);
			local tb, subCmd = DKPTooltip_GetCmd(subCmd);
			tr,tg,tb=tonumber(tr),tonumber(tg),tonumber(tb);
			if(tr==nil or tg==nil or tb==nil or tr<=0 or tr>=1 or tg<=0 or tg>=1 or tg<=0 or tb>=1) then
				DKPT['color']['tr'],DKPT['color']['tg'],DKPT['color']['tb']=tr,tg,tb;
				print("DKPTooltip - Color on "..cmd.." changed successfully!");
			else
				print("DKPTooltip - Useage: '/dkpt color "..cmd.." <r> <g> <b>' where r, g, b are normalized rgb-values (i.e. '1 1 1' means '255 255 255' or 'FF FF FF').");
			end
		elseif(cmd=="value") then
			local vr, subCmd = DKPTooltip_GetCmd(subCmd);
			local vg, subCmd = DKPTooltip_GetCmd(subCmd);
			local vb, subCmd = DKPTooltip_GetCmd(subCmd);
			vr,vg,vb=tonumber(vr),tonumber(vg),tonumber(vb);
			if(vr==nil or vg==nil or vb==nil or vr<=0 or vr>=1 or vg<=0 or vg>=1 or vg<=0 or vb>=1) then
				DKPT['color']['vr'],DKPT['color']['vg'],DKPT['color']['vb']=vr,vg,vb;
				print("DKPTooltip - Color on "..cmd.." changed successfully!");
			else
				print("DKPTooltip - Useage: '/dkpt color "..cmd.." <r> <g> <b>' where r, g, b are normalized rgb-values (i.e. '1 1 1' means '255 255 255' or 'FF FF FF').");
			end
		else
			print("DKPTooltip - Useage: '/dkpt color <text/value>'");
		end
	else
		print("DKPTooltip - Commands:\n 'toggle' to toggle dkp-cost on tooltips.\n 'halfcost' to toggle showing the half DKP-cost aswell.\n 'color' to change the color in the tooltip.");
	end
end

function DKPTooltip_GetCmd(msg)
	if(msg) then
		local a,b,c = strfind(msg, "(%S+)");
		if(a) then
			return c, strsub(msg, b+2);
		else	
			return "";
		end
	end
end